﻿<!DOCTYPE html>
<html>
<head>
    <title>Testing JWT</title>
    <meta charset="utf-8" />
    <script src="Scripts/jquery-3.0.0.min.js"></script>
</head>
<body>
    <h1>Testing JWT</h1>
    <button type="button" onclick="doLogin()" id="login">Login</button>
    <button type="button" onclick="doCallApi()" id="callApi">Call Protected API ([Authorize])</button>
    <button type="button" onclick="doCallAdminApi()" id="callAdminApi">Call Protected Admin API [Authorize(Roles = "Admin")]</button>
    <button type="button" onclick="doCallAdminApiUsingGet()" id="callAdminApiUsingGet">Call Protected Admin API, Test $.ajaxSetup</button>
    <button type="button" onclick="doRefreshToken()" name="refreshToken">Refresh Token</button>
    <button type="button" onclick="doLogout()" name="logout">Logout</button>
    <button type="button" onclick="doShowAllUser()" name="showAllUser">ShowUsers</button>
    <button type="button" onclick="doShowUserName()" name="showUserName">ShowUserName</button>
    <!--<button type="button" onclick="doSearchByName()" name="SearchByName">SearchByName</button-->>

    <!--<button type="button" onclick="doRgister()" id="Register">RegisterNew User</button>-->

    
    <script type="text/javascript">

        var jwtToken;
        var refreshToken;

        function isNullOrEmpty(value) {
            return (typeof value == 'undefined' || !value);
        }


        function doLogin() {
            $.ajax({
                url: "/login", // web.config --> appConfiguration -> tokenPath
                data: {
                    username: "Maryam",
                    password: "1234",
                    grant_type: "password",
                  
                },
                type: 'POST', // POST `form encoded` data
                contentType: 'application/x-www-form-urlencoded'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));

                jwtToken = response.access_token; // For every request to Controller
                refreshToken = response.refresh_token; //Request for new accesstoken
                setHeadersOfAllRequests();
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));
            });
        }

        function doRefreshToken() {
            if (isNullOrEmpty(refreshToken)) {
                alert('Please login first.');
                return;
            }

            // obtaining new tokens using the refresh_token should happen only if the id_token has expired.
            // it is a bad practice to call the endpoint to get a new token every time you do an API call.
            $.ajax({
                url: "/login", // web.config --> appConfiguration -> tokenPath
                data: {
                    grant_type: "refresh_token",
                    refresh_token: refreshToken
                },
                type: 'POST', // POST `form encoded` data
                contentType: 'application/x-www-form-urlencoded'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));

                jwtToken = response.access_token;
                refreshToken = response.refresh_token;
                setHeadersOfAllRequests();
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));
            });
        }

  

        function doCallApi() {
            if (isNullOrEmpty(jwtToken)) {
                alert('Please login first.');
                return;
            }

            $.ajax({
                headers: { 'Authorization': 'Bearer ' + jwtToken },
                url: "/api/MyProtectedApi",
                type: 'GET'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));

                if (refreshToken && xhr.status === 401) {
                    //doRefreshToken();
                }
            });
        }


        function doShowAllUser() {
            if (isNullOrEmpty(jwtToken)) {
                alert('Please login first.');
                return;
            }

            $.ajax({
                headers: { 'Authorization': 'Bearer ' + jwtToken },
                url: "/api/show",
                type: 'GET'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));

                if (refreshToken && xhr.status === 401) {
                    //doRefreshToken();
                }
            });
        }
        function doShowAllUser() {
            if (isNullOrEmpty(jwtToken)) {
                alert('Please login first.');
                return;
            }

            $.ajax({
                headers: { 'Authorization': 'Bearer ' + jwtToken },
                url: "/api/showuse",
                type: 'GET'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));

                if (refreshToken && xhr.status === 401) {
                    //doRefreshToken();
                }
            });
        }


        function doCallAdminApi() {
            if (isNullOrEmpty(jwtToken)) {
                alert('Please login first.');
                return;
            }

            $.ajax({
                headers: { 'Authorization': 'Bearer ' + jwtToken },
                url: "/api/MyProtectedAdminApi",
                type: 'GET'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));

                if (refreshToken && xhr.status === 401) {
                    //doRefreshToken();
                }
            });
        }

        function doLogout() {
            if (isNullOrEmpty(jwtToken)) // will check if the value is undefined or null.
            {
                alert('Please login first.');
                return;
            }

            $.ajax({
                headers: { 'Authorization': 'Bearer ' + jwtToken },
                url: "/api/user/logout",
                type: 'GET'
            }).then(function (response) {
                alert(JSON.stringify(response, null, ' '));

                jwtToken = '';
                refreshToken = '';
            }, function (xhr, status, error) {
                var response = xhr.responseText;
                alert(JSON.stringify(JSON.parse(response), null, ' '));
            });
        }

        function setHeadersOfAllRequests() {
            $.ajaxSetup({
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('Authorization', 'Bearer ' + jwtToken);
                }
            });
        }

        function doCallAdminApiUsingGet() {
            if (isNullOrEmpty(jwtToken)) {
                alert('Please login first.');
                return;
            }
            // Testing `setHeadersOfAllRequests` without setting the `headers` directly
            $.get("/api/MyProtectedAdminApi")
             .then(function (response) {
                 alert(JSON.stringify(response, null, ' '));
             }, function (xhr, status, error) {
                 var response = xhr.responseText;
                 alert(JSON.stringify(JSON.parse(response), null, ' '));

                 if (refreshToken && xhr.status === 401) {
                     //doRefreshToken();
                 }
             });
        }
    </script>
</body>
</html>